<template>
    <div>
		<h1 v-if="foto._id" class="center-text">Alterar foto</h1>
    	<h1 v-else class="center-text">Incluir foto</h1>
		<h2 class="center-text">{{ foto.titulo }}</h2>

		<form @submit.prevent="grava()" class="formulario">
			<div class="controle">
				<input id="titulo" name="titulo" v-validate="'required|min:5|max:20'" :class="{ 'is-danger': errors.has('titulo') }" placeholder="Título" autocomplete="off" v-model="foto.titulo">
				<span class="erro" v-show="errors.has('titulo')">{{ errors.first('titulo') }}</span>
			</div>

			<div class="controle">
				<input id="url" name="url" v-validate="'required'" :class="{ 'is-danger': errors.has('url') }" placeholder="URL, base64, relative path..." autocomplete="off" v-model.lazy="foto.url">
				<span class="erro" v-show="errors.has('url')">{{ errors.first('url') }}</span>
				<img class="visualizacao" :src="foto.url" :alt="foto.titulo" v-show="!errors.has('url')"/>
			</div>

			<div class="controle">
				<textarea id="descricao" placeholder="Descrição" autocomplete="off" v-model="foto.descricao"></textarea>
			</div>

			<div class="centralizado">
				<my-button rotulo="Gravar" tipo="submit"/>
				<router-link to="/"><my-button rotulo="Voltar" tipo="button"/></router-link>
			</div>
		</form>
    </div>
</template>

<script>

import Foto from '../../domain/foto/Foto';
import FotoService from '../../domain/foto/FotoService';
import Botao from '../shared/botao/Botao.vue';

export default {

    components: {
		'my-button': Botao
	},
	data() {
		return {
			foto: new Foto(),
			id: this.$route.params.id
		}
	},
	created() {
		this.service = new FotoService(this.$resource);

		if (this.id) {
			this.service.busca(this.id)
				.then(foto => this.foto = foto);
		}
	},
	methods: {
		grava() {
			this.resource = this.$resource('v1/fotos');

			this.$validator
				.validateAll()
				.then(success => {
					if(success) {
						this.service.cadastra(this.foto)
							.then(() => {
								this.$router.push({ name: 'home' });
								this.foto = new Foto();
							}, err => console.log(err));
					}
				});
		}
	}
}

</script>
<style lang="scss">

	.formulario {
		width: 60%;
		margin: 0 auto;
	}

	.visualizacao {
		max-width: 100%;
	}

    .controle {
		font-size: 1.2em;
		margin-bottom: 20px;

    }
    .controle label {
		display: block;
		font-weight: bold;
    }

  	.controle input, .controle textarea {
		width: 100%;
		font-size: inherit;
		border-radius: 5px;
		border: 1px solid #666;
		padding: 10px;
		line-height: 1.4;
		font-size: 16px;

		&.is-danger {
			border-color: red;
		}
    }

	.controle .erro {
		color: red;
	}

</style>